<template>
    <div class="q-pa-md q-gutter-sm">
        <div class="row">
            <div class="col-md-1"></div>
            <div class="col items-center">
                <q-banner rounded class="bg-grey-3 ">
                    <template v-slot:avatar>
                        <q-avatar :key="store.getters.getAvatarKey" color="default" text-color="white" size="100px" class="editable-avatar" @click="dialogChangeAvatar = true">
                            <img :src="user.avatar">
                        </q-avatar>
                    </template>
                    <div class="row"><div class="col text-center text-weight-bold text-h4 text-blue-grey-10">{{user.firstName}} {{user.lastName}}</div></div>
                    <div class="row">
                        <div class="col text-center text-blue-grey-8">@{{user.username}}</div>
                    </div>
                    <div class="row">
                        <div class="col text-center text-blue-grey-8">From {{user.organization}}</div>
                    </div>
                    <div class="row">
                        <div class="col-md-6 col-xs-12 text-center text-blue-grey-8">{{user.age}} years old</div>
                        <div class="col-md-6 col-xs-12 text-center text-blue-grey-8">{{user.gender}}</div>
                    </div>
                </q-banner>
            </div>
            <div class="col-md-1"></div>
        </div>
        <div class="row">
            <div class="col-md-1"></div>
            <div class="col-md-4 col-xs-12">
                <q-card flat >
                    <q-form @submit="updateUser()"  >
                        <q-card-section>
                            <div class="text-h6 text-blue-grey-8">Personal Informations</div>
                        </q-card-section>
                        <q-card-section>
                            <div class="q-gutter-lg">
                                <q-input type="email" v-model="user.email" label="Email"  />
                                <q-input type="text" v-model="user.firstName" label="First Name" />
                                <q-input type="text" v-model="user.lastName" label="Last Name" />
                                <q-input type="text" v-model="user.organization" label="Organization"  />
                                <q-input type="text" v-model="user.status" label="Status" />
                                <q-input type="number" v-model="user.age" label="Age"  />
                                <q-select v-model="user.gender" :options="genders" label="Gender" />
                            </div>
                        </q-card-section>
                        <q-card-actions align="right">
                            <q-btn label="Save Modifications" type="submit" icon="save" color="primary" :loading="savingModifs"/>
                        </q-card-actions>
                    </q-form>
                </q-card>
            </div>
            <div class="col-md-1"></div>
            <div class="col-md-4 col-xs-12">
                <q-card flat>
                    <q-card-section>
                        <div class="text-h6 text-blue-grey-8">Actions</div>
                    </q-card-section>
                    <q-card-section>
                        <div class="q-gutter-lg">
                            <q-form @submit="changePwd()" >
                                <q-input bottom-slots :type="isPwd ? 'password' : 'text'" rounded v-model="tempPwd" label="New Password" hint="Password" dense lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']">
                                    <template v-slot:before>
                                        <q-avatar :key="store.getters.getAvatarKey" color="default" text-color="white" >
                                            <img :src="user.avatar">
                                        </q-avatar>
                                    </template>

                                    <template v-slot:append>
                                        <q-icon :name="isPwd ? 'visibility_off' : 'visibility'" class="cursor-pointer" @click="isPwd = !isPwd" />
                                    </template>

                                    <template v-slot:after>
                                        <q-btn color="negative" type="submit" label="Change Password" dense flat icon="lock" />
                                    </template>
                                </q-input>
                            </q-form>
                        </div>
                    </q-card-section>
                </q-card>
            </div>
            <div class="col-md-1"></div>
        </div>

        <q-dialog v-model="dialogChangeAvatar" :maximized="maximizedChangeAvatarToggle" transition-show="fade" transition-hide="fade" >
            <q-card style="width: 500px; max-width: 80vw;">
                <q-bar>
                    <q-space />
                    <q-btn dense flat icon="minimize" @click="maximizedChangeAvatarToggle = false" :disable="!maximizedChangeAvatarToggle">
                        <q-tooltip v-if="maximizedChangeAvatarToggle" content-class="bg-white text-primary">Minimize</q-tooltip>
                    </q-btn>
                    <q-btn dense flat icon="crop_square" @click="maximizedChangeAvatarToggle = true" :disable="maximizedChangeAvatarToggle">
                        <q-tooltip v-if="!maximizedChangeAvatarToggle" content-class="bg-white text-primary">Maximize</q-tooltip>
                    </q-btn>
                    <q-btn dense flat icon="close" v-close-popup>
                        <q-tooltip content-class="bg-white text-primary">Close</q-tooltip>
                    </q-btn>
                </q-bar>

                <q-card-section>
                    <div class="text-h6 text-blue-grey-8">Drap and Drop your file below</div>
                </q-card-section>
                
                <q-card-section >
                    <q-uploader :url="$store.getters.getSource + '/uploadFile'" color="default" 
                    label="Upload Avatar"  style="max-width: 200px; max-height: 200px" @uploaded="forceRerenderAvatar()"
                    method="POST" field-name="files" :headers="[{name:'Authorization', value: 'Bearer '+this.$cookies.get('axesstoken')}]" />
                </q-card-section>
            </q-card>
        </q-dialog>
    </div>
</template>
<script>
import api from '../boot/backend-api';
import Store from '../store/index';


export default {
    name: 'settings',
    data () {
        return {
            user: this.$store.getters.getUserInfos,
            genders: ['male', 'female'],
            store: Store,
            dialogChangeAvatar: false,
            maximizedChangeAvatarToggle: false,
            alerts: { 'saveerror': { color: 'negative', message: 'Could not save the data.', icon: 'report_problem' },
                'savesuccess': { color: 'positive', message: 'Modifications saved' },
                'denied': { color: 'warning', icon: 'report_problem', message: 'Denied! Contact an administrator.'}
            },
            savingModifs: false,
            isPwd: true,
            tempPwd: ''
        }
    },
    methods: {
        updateUser() {
            this.savingModifs = true;
            let promise = api.updatePersonalInfos(this.user);
            promise.then(response => {
                this.store.commit('update_user', {user: response.data});
                this.showNotif('top-right', 'savesuccess');
                this.savingModifs = false;
            }).catch(error => {
                console.log(error);
                this.showNotif('bottom-right', 'saveerror');
                this.savingModifs = false;
            });
        },
        changePwd() {
            api.changePwd({username : this.store.getters.getUserInfos.username, password: this.tempPwd})
            .then(response => {
                this.tempPwd = null;
                if(response.data == true){
                    this.showNotif('top-right', 'savesuccess');
                }else {
                    this.showNotif('top-right', 'denied');
                }
            }).catch(error => {
                this.tempPwd = null;
                console.log(error);
                this.showNotif('bottom-right', 'saveerror');
            });
        },
        forceRerenderAvatar() {
            this.$store.commit('increment_avatar_key');
            this.showNotif('top-right', 'savesuccess');
        },
        showNotif (position, alert) {
            const { color, textColor, multiLine, icon, message, avatar, actions } = this.alerts[alert];
            const buttonColor = color ? 'white' : void 0;
            this.$q.notify({
                color,
                textColor,
                icon: icon,
                message,
                position,
                avatar,
                multiLine,
                actions: actions,
                timeout: 2000
            })
        }
    }
}
</script>
<style scoped>
    .editable-avatar:hover {
        cursor: pointer;
        opacity: 0.7;
    }
</style>
